-- 判定用。tbl中にxがあればそのindexを返す。無ければnil.

function is_in_tbl (x,tbl)
  local i
  for index,value in pairs(tbl) do
    if x == value or x == string.upper(value)
      then i = index
      else
      end
  end
  return i
end


-- pannigにてstr_tblに登録した順に切り替える。上のis_in_tblを判定で使う。

function toggl_str (str_tbl)

 if renoise.song().transport.edit_mode
  
  then  
   local pan_str = renoise.song().selected_note_column.panning_string
   local max = #(str_tbl)
   local i =  is_in_tbl(pan_str,str_tbl)
   
    if
      i == nil
    then
      renoise.song().selected_note_column.panning_string
      = string.upper(str_tbl[1])
    elseif 
      i >=1 and i <= max-1
    then
      renoise.song().selected_note_column.panning_string
      = string.upper(str_tbl[i+1])
    elseif
      i == max
    then
      renoise.song().selected_note_column.panning_string
      = string.upper(str_tbl[1])
    else
    end   
    
  else
    return nil
  end        
end





function set_str (str)
  if renoise.song().transport.edit_mode
  then
    local str_upper = string.upper (str)
    renoise.song().selected_note_column.panning_string = str_upper
  else
    return nil
  end
end

  
function pan_val_minus ()
  local pan_val = renoise.song().selected_note_column.panning_value
  if renoise.song().transport.edit_mode and (pan_val > 0)
  then
   renoise.song().selected_note_column.panning_value = pan_val - 1
  else
   return nil
  end
end

  
function pan_val_plus ()
  local pan_val = renoise.song().selected_note_column.panning_value
  if renoise.song().transport.edit_mode and (pan_val < 255)
  then
   renoise.song().selected_note_column.panning_value = pan_val + 1
  else
   return nil
  end
end


--[[
--Keybindigs
--]]

 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:notecut_F5_in_panning",
   invoke = function() 
    set_str('f5')
   end
 }
 
 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:clear_panning",
   invoke = function() 
    set_str('..')
   end
 }


  renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:plus_panning_value",
   invoke = function() 
    pan_val_plus()
   end
 }

  renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:minus_panning_value",
   invoke = function() 
    pan_val_minus()
   end
 }
 
 
 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:toggle loop FX in pan",
   invoke = function() 
   toggl_str ({"f5",".."})
   end
 }  

 
 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:toggle loop DX in pan",
   invoke = function() 
   toggl_str ({"d4","d6","d8",".."})
   end
 }  
   

 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:toggle loop EX in pan",
   invoke = function() 
   toggl_str ({"e6","e4","e3","e2",".."})
   end
 }  





 
 --[[
--GUI おまけ


function test_main ()
local vb = renoise.ViewBuilder()

local dialog_content = 
    vb:column {
  vb:button {
        width = 180,
      
        text = "notecut F5",
        notifier =
          function()
                set_str ("f5")
          end
  },
      
  vb:button {
        width = 180,
        
        text = "clear panning",
        notifier =
          function()
                set_str ("..")
          end
  }
      
    }
 renoise.app():show_custom_dialog("set commands to panning" , dialog_content)
end

renoise.tool():add_menu_entry {
  name = "Pattern Editor:set_commands_to_panning...",
  invoke = function()
   test_main()
  end
}

--]]

